#include<net/gen/inet.h>

static mountlist head = NULL;


static int addClient(caddr_t path, struct sockaddr_in sin, unsigned int pathLen)
{
	mountlist new, temp;	
	char * hostname;
	new = (mountlist)malloc(sizeof(struct mountlist));
	if(!new)
	{
		printf("\n Could not allocate memory to new in addClient()");
		exit(0);
	}
	hostname = inet_ntoa(sin.sin_addr.s_addr); 
	new->ml_hostname = (char *)malloc(strlen(hostname));
	if(!new->ml_hostname)
	{
		printf("\n Could not allocate memory to new->ml_hostname");
		exit(0);
	}
 	new->ml_directory = (char *)malloc(pathLen);
	if(!new->ml_directory)
	{
		printf("\n Could not allocate memory to new->ml_directory");
		free(new->ml_hostname);	
		exit(0);
	}
	strcpy(new->ml_hostname, hostname);
	strcpy(new->ml_directory, path);
	new->next = NULL;	
	temp = head;	
	if(temp!=NULL)
	{
		while(temp->next)
		{
			temp = temp->next;	
		}	
		temp->next = new;
	}
	else
	{
		head = new;
	}
	return(0);
} 

/*
 * get real length of a filehandle
 */
u_int fh_length(unfs_fh_t fh)
{
    return fh.len + sizeof(fh.len) + sizeof(fh.dev) + sizeof(fh.ino) +
        sizeof(fh.gen) + sizeof(fh.pwhash);
}



int mountDir_SendReply(XDR xdr, int sockFd, struct sockaddr_in sin, unsigned int pathLen, caddr_t path)
{
	unfs_fh_t filehandle;
	mountstat status;
	unisgned int fileHandle_len = 0; 
	unsigned int auth_flavor_len = 1;
	filehandle = fh_comp_raw(path); 
	addClient(path, sin, pathLen);
	if(filehandle.dev == 0 && filehandle.ino == 0)
	{
		status = MNTERR_NOENT; /* as of now ..shall have to deal with this better later */
	}
	else
	{
		status = MNT_OK;
	}
	*(int *)xdr->x_private = (u_long) htonl(status);
	xdr->x_private = xdr->x_private + 4;
	if(status == MNT_OK)
	{
		fileHandle_len = fh_length(filehandle);
		*(int *)xdr->x_private = (u_long) htonl(fileHandle_len);
		xdr->x_private = xdr->x_private + 4;
		/* Copying opaque data */	
		memcpy(xdr->x_private, (char *)filehandle,fileHandle_len);	
		xdr->x_private = xdr->x_private + fileHandle_len;
		/* Now copying the authentication flavours  */
		xdr->x_private = (u_long)htonl(auth_flavor_len);
		xdr->x_private = xdr->x_private + 4;
		xdr->x_private = (u_long)htonl(AUTH_UNIX);
		xdr->x_private = xdr->x_private + 4;
	}
	return(0);
}
