#include"clnt.h"
#include<stdlib.h>
#include<net/gen/in.h>
#include<net/gen/inet.h>
#include<netinet/in.h>
#include<sys/socket.h>
#include"auth.h"
#include"xdr.h"
#include"xprt.h"
#include"rpc_msg.h"
#include"portmap.h"
#define MAXSIZE 8800

void printXDR(char * buff, int len)
{
	int i = 0;
	 printf("\n ********************************** \n");
	for(i=0; len>0;  i++)
	{
		printf("\n %u", ntohl(*(u_long *)buff));
		buff = buff + 4;
		len = len - 4;
	}
	 printf("\n ********************************** \n");
	printf("\n");
}

int validateReply(int sockFd, int xid)
{
	XDR xdr_recv;
	struct sockaddr_in sin;	
	socklen_t sin_len;
	int len;
	u_long  xid_recv;
	u_long direction;	
	while(1)
	{
		len = recvfrom(sockFd, xdr_recv.x_base, MAXSIZE , 0, (struct sockaddr *) (&sin), &sin_len);
		xdr_recv.x_private = xdr_recv.x_base;  
		if(len == -1)
		{
			/* you	need to resend */
			break;
		}
		xid_recv =  (int32_t)ntohl(*((u_long *)xdr_recv.x_private));
		if(xid_recv != xid)
		{
			continue; /* we have to wait for another response */
		}
		xdr_recv.x_private = xdr_recv.x_private + 4;
		direction = (int32_t)ntohl(*((u_long *)xdr_recv.x_private));
		if(direction != REPLY)
		{
			continue; /* we have to wait for a reply ! */ 
		}
		/* authentication verification would go in here */
		break;
	}		
	return len;	
}

int rpc_register(int sd, unsigned int progNum, unsigned int verNum, unsigned int proto,  unsigned int portNum, int dummy)
{
	struct sockaddr_in sin;
	struct XDR xdr_send;
	unsigned int msgLen;
	unsigned int rpc_version = 2;
	unsigned int pmap_progNum, pmap_procVers;
	unsigned int xid = random();
	int retVal;
	socklen_t len = sizeof(struct sockaddr_in); 
	printf("\n xid is : %d ", xid);
	printf("\n");
	pmap_progNum = 100000;
	pmap_procVers = 2;
	sin.sin_family = AF_INET;
	sin.sin_port = htons(111);
	inet_aton("127.0.0.1", &sin.sin_addr.s_addr);
	printf("\n addr is %x \n ", sin.sin_addr.s_addr);
	xdr_send.x_base = (char *)malloc(MAXSIZE);
	xdr_send.x_private = xdr_send.x_base;
	*(u_long *)xdr_send.x_private= (u_long)htonl((u_long)(xid));
	xdr_send.x_private = xdr_send.x_private + 4;
 	*(u_long *)xdr_send.x_private =(u_long) htonl((u_long)(CALL));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(rpc_version));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *) xdr_send.x_private = (u_long)htonl((u_long)(pmap_progNum));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(pmap_procVers));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(PMAPPROC_SET));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(AUTH_NULL));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(0));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(AUTH_NULL));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(0));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(progNum));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(verNum));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(proto));
	xdr_send.x_private = xdr_send.x_private + 4;
	*(u_long *)xdr_send.x_private = (u_long)htonl((u_long)(portNum));
	xdr_send.x_private = xdr_send.x_private + 4;
	msgLen = xdr_send.x_private - xdr_send.x_base;
	len = sendto(sd, xdr_send.x_base, msgLen, 0, (struct sockaddr *)&sin, len);	
	printXDR(xdr_send.x_base, msgLen);
	printf("\n Sent %d bytes ", len);
	printf("RPC: Registering with portmapper: progNum: %d  verNum:  %d proto: %d  portnum: %d", progNum, verNum, proto, portNum);
	if(dummy)
	{
		retVal = validateReply(sd, xid);
	}
	return (retVal);
}
